Bug 1416496 - getaddrinfo() call returns wrong IPv6 address if nscd is used
Summary: getaddrinfo() call returns wrong IPv6 address if nscd is used
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: glibc
Version: 6.9
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: ---
Assignee: Florian Weimer
QA Contact: Sergey Kolosov
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-01-25 15:54 UTC by Sergey Kolosov
Modified: 2017-03-21 10:38 UTC (History)
8 users (show)

Fixed In Version: glibc-2.12-1.209.el6
Doc Type: No Doc Update
Doc Text:
undefined
Clone Of:
Environment:
Last Closed: 2017-03-21 10:38:24 UTC
Target Upstream Version:


Attachments (Terms of Use)
getaddrinfo.c test program originally from bug 970090 (1.76 KB, text/plain)
2017-01-25 15:54 UTC, Sergey Kolosov
no flags Details


Links
System ID Priority Status Summary Last Updated
Red Hat Bugzilla 1223095 None CLOSED access to uninitialized memory in getaddrinfo if nscd is running 2019-10-31 19:14:40 UTC
Red Hat Product Errata RHSA-2017:0680 normal SHIPPED_LIVE Moderate: glibc security and bug fix update 2017-03-21 12:36:34 UTC

Internal Links: 1223095

Description Sergey Kolosov 2017-01-25 15:54:57 UTC
Created attachment 1244293 [details]
getaddrinfo.c test program originally from bug 970090

Description of problem:
getaddrinfo() call returns wrong IPv6 address if nscd is used

Version-Release number of selected component:
glibc-2.12-1.208.el6

Steps to Reproduce:
1. Install nscd and run it
2. ./getaddrinfo AF_INET6 localhost
[0 root@host ~]# ./getaddrinfo AF_INET6 localhost 
Hints family=10
host=7f00:1::, family=10 addr=7f00:1::
host=7f00:1::, family=10 addr=7f00:1::
host=7f00:1::, family=10 addr=7f00:1::
[0 root@host ~]#

Actual results:

host=7f00:1::, family=10 addr=7f00:1::
host=7f00:1::, family=10 addr=7f00:1::
host=7f00:1::, family=10 addr=7f00:1::

Expected results:

host=localhost, family=10 addr=::1
host=localhost, family=10 addr=::1
host=localhost, family=10 addr=::1

Comment 1 Florian Weimer 2017-01-25 16:04:28 UTC
Sergey, do you know if this is a regression in glibc-2.12-1.208.el6?  Thanks.

Comment 2 Sergey Kolosov 2017-01-25 16:57:19 UTC
(In reply to Florian Weimer from comment #1)
> Sergey, do you know if this is a regression in glibc-2.12-1.208.el6?  Thanks.

It is glibc-2.12-1.208.el6 regression and it is related to patch for bug 1223095.
Upstream fix: https://sourceware.org/git/gitweb.cgi?p=glibc.git;a=commit;h=8dc9751764eb1bedf06d19695524b31a16773413

I have tested the upstream fix on x86_64 host, it works.

Comment 10 errata-xmlrpc 2017-03-21 10:38:24 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2017-0680.html


Note You need to log in before you can comment on or make changes to this bug.